#ifndef ___CLIB_H_______
#define ___CLIB_H_______
#include <hiredis/hiredis.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>
const double g = 9.8;

#define TOLL_DBL 1e-6

#ifndef QUEUE_TERM
#define QUEUE_TERM "work:queue:TERM"
#endif
#ifndef QUEUE_PIP_BASE
#define QUEUE_PIP_BASE "work:queue:PIP"
#endif
#ifndef QUEUE_POP_BASE
#define QUEUE_POP_BASE "work:queue:POP"
#endif
#ifndef QUEUE_PII_BASE
#define QUEUE_PII_BASE "work:queue:PII"
#endif
#ifndef QUEUE_POI_BASE
#define QUEUE_POI_BASE "work:queue:POI"
#endif
#ifndef QUEUE_CI_BASE
#define QUEUE_CI_BASE "work:queue:CI"
#endif
#ifndef QUEUE_CO_BASE
#define QUEUE_CO_BASE "work:queue:CO"
#endif
#ifndef QUEUE_SI_BASE
#define QUEUE_SI_BASE "work:queue:SI"
#endif
#ifndef QUEUE_SO_BASE
#define QUEUE_SO_BASE "work:queue:SO"
#endif
#ifndef QUEUE_SOA_BASE
#define QUEUE_SOA_BASE "work:queue:SOA"
#endif
#ifndef QUEUE_PC
#define QUEUE_PC "work:queue:PC"
#endif
#ifndef QUEUE_CP
#define QUEUE_CP "work:queue:CP"
#endif

#ifndef QUEUE_PAPB_BASE
#define QUEUE_PAPB_BASE "work:queue:PAPB"
#endif
#ifndef QUEUE_BPAP_BASE
#define QUEUE_BPAP_BASE "work:queue:BPAP"
#endif
#ifndef QUEUE_PB_BASE
#define QUEUE_PB_BASE "work:queue:PB"
#endif
#ifndef QUEUE_BP_BASE
#define QUEUE_BP_BASE "work:queue:BP"
#endif
#ifndef QUEUE_CB_BASE
#define QUEUE_CB_BASE "work:queue:CB"
#endif
#ifndef QUEUE_BC_BASE
#define QUEUE_BC_BASE "work:queue:BC"
#endif
#ifndef QUEUE_SB_BASE
#define QUEUE_SB_BASE "work:queue:SB"
#endif
#ifndef QUEUE_BS_BASE
#define QUEUE_BS_BASE "work:queue:BS"
#endif
#ifndef QUEUE_PB
#define QUEUE_PB "work:queue:PB"
#endif
#ifndef QUEUE_BP
#define QUEUE_BP "work:queue:BP"
#endif
#ifndef QUEUE_CB
#define QUEUE_CB "work:queue:CB"
#endif
#ifndef QUEUE_BC
#define QUEUE_BC "work:queue:BC"
#endif
#ifndef QUEUE_SB
#define QUEUE_SB "work:queue:SB"
#endif
#ifndef QUEUE_BS
#define QUEUE_BS "work:queue:BS"
#endif
#ifndef QUEUE_MB
#define QUEUE_MB "work:queue:MB"
#endif
#ifndef QUEUE_BM
#define QUEUE_BM "work:queue:BM"
#endif

#ifndef ENV_DBHOSTNAME
#define ENV_DBHOSTNAME "127.0.0.1"
#endif
#ifndef ENV_DBNAME
#define ENV_DBNAME "env_db_website"
#endif
#ifndef ENV_DBUSER
#define ENV_DBUSER "env_db_website_user"
#endif
#ifndef ENV_DBPASSWORD
#define ENV_DBPASSWORD "env_db_website_user_password"
#endif
#ifndef ENV_DBPORT
#define ENV_DBPORT 5432
#endif

redisContext *conn_to_redis(char **argv);

void from_double_to_timespec(struct timespec *req, double t);
void print_all(int, const char *, ...);
void *limit_saturate_f(void *(*f)(void *), void *arg, double t, int *res, double *);
char *hostname_to_ip(const char * hostname);
void monitored_sleep(redisContext *conn, const char *function, double, unsigned type, ...);
void only_advance_time_monitored_sleep(redisContext *conn, const char *function, unsigned type, ...);
char *blocking_read(redisContext *conn, const char *queue, const char *function);
int check_assumptions(double tau_s, double **T, unsigned T_num, unsigned *size_T);
void init_time();
char *get_curr_time_psql();
void init_rand_monitored_sleep(int s);
#endif
