import psycopg2
import os
import sys
import redis
import time
import random
import datetime

def blocking_read(rc, db_env, q, fun_name):
    res = rc.brpop(q, 0)
    return (res[1], 0) 

def init_rand_mon_sleep(s):
    random.seed(s)

def monitored_sleep_check(rc, db_env, fun_name, cause=[""], fixed_time=0):
    if not(hasattr(monitored_sleep_check, "causes")):
        monitored_sleep_check.causes = {}
    if fixed_time != 0:
        time.sleep(fixed_time)
        return fixed_time
    else:
        if not(str(cause) in monitored_sleep_check.causes):
            times = set()
            for c in cause:
                sql = "SELECT single_time FROM function_time INNER JOIN function_info ON function_info.id = function_id WHERE fname = '%s' AND statm_type = '%s'" %(fun_name, c)
                res = exec_and_retrieve(db_env, sql)
                if times == set():
                    for r in res:
                        times.add(r["single_time"])
                else:
                    times2 = []
                    for r in res:
                        times2 += r["single_time"]
                    times1 = list(times)
                    times = set()
                    for t1 in times1:
                        for t2 in times2:
                            times.add(t1 + t2)
            monitored_sleep_check.causes[str(cause)] = times
        to_be_slept = random.sample(list(monitored_sleep_check.causes[str(cause)]), 1)[0]
        time.sleep(to_be_slept)
        return to_be_slept

def db_connect(conn_string):
    try:
        conn = psycopg2.connect(conn_string)
        conn.autocommit = True
        db = conn.cursor()
    except Exception as inst:
        raise Exception("Internal error: failed to connect to db with params " + conn_string + " because of " + str(inst))
    return (conn, db)

def exec_and_retrieve(db, sql, output = True):
    result = []
    try:
        db.execute(sql)
        if (output):
            res = db.fetchone()
            while (res != None):
                result += [{}]
                for j in range(len(db.description)):
                    if (res[j] == None):
                        result[-1][db.description[j].name] = None
                    else:
                        result[-1][db.description[j].name] = res[j]
                res = db.fetchone()
    except Exception as inst:
        raise Exception("Internal error while executing SQL command\n\t" + sql + "\nThe error is:\n\t" + str(inst))
    return result

def str_or_null(x, mode = 'non_apexes'):
    if (x == None):
        return "NULL"
    if (mode == 'apexes'):
        return "'" + str(x) + "'"
    elif (mode == 'timeslot'):
        return "TIMESTAMP '" + str(x) + "' AT TIME ZONE 'UTC'"
        # return "TIMESTAMP '" + str(x).split()[0] + "T" + str(x).split()[1] + "' AT TIME ZONE 'UTC'"
    return str(x)

def print_cmd_line(argv):
    print("Printing command line as typed:")
    cmd_line = ""
    for i in range(len(argv)):
        cmd_line += argv[i] + " "
    print(cmd_line)
    sys.stdout.flush()

def print_all_options(args):
    print("Printing all options with corresponding values:")
    max_len = max([len(arg) for arg in vars(args)])
    for arg in sorted(vars(args)):
        print("\t" + arg + ":" + " "*(max_len - len(arg) + 1) + str(getattr(args, arg)))
    sys.stdout.flush()

def progress(t, max_time):
    print("Elapsed %d out of %d (%.2lf%%)" %(t, max_time, 100*float(t)/max_time))
    sys.stdout.flush()
    
