-- This script must be executed by a user having superuser privileges

create database env_db_website;

create role env_db_website_user with password 'env_db_website_user_password' login;

\c env_db_website;

create table item_customer_other_info(
	id serial,
	item_id integer not null, --ext ref to other DB
	customer_id integer not null, --ext ref to other DB
	order_num integer,
	order_date_due float,
	-- constraint item_other_info_ref foreign key(item_id) references item_corr(id),
	constraint item_customer_other_info_at_least_one check(order_num is not null or order_date_due is not null),
	constraint item_customer_other_info_pkey primary key(id)
);

create table item_producer_other_info(
	id serial,
	item_id integer not null,
	producer_id integer not null,
	prod_starting integer, --only one value
	prod_min integer, --only one value
	prod_time float, --multiple values
	-- constraint item_other_info_ref foreign key(item_id) references item_corr(id),
	constraint item_producer_other_info_at_least_one check(prod_min is not null or prod_time is not null),
	constraint item_producer_other_info_pkey primary key(id)
);

create table item_shipper_other_info(
	id serial,
	item_id integer not null,
	shipper_id integer not null,
	ship_time float not null,
	-- constraint item_other_info_ref foreign key(item_id) references item_corr(id),
	constraint item_shipper_other_info_pkey primary key(id)
);

create table function_info(
	id serial,
	fname varchar(50) not null,
	queue_in_mon_sl varchar(50) not null,
	queue_out_mon_sl varchar(50) not null,
	constraint function_info_pkey primary key(id)
);

create table function_time(
	id serial,
	function_id integer not null,
	single_time float not null,
	statm_type varchar(50) not null,
	constraint function_time_ref foreign key(function_id) references function_info(id),
	constraint function_time_pkey primary key(id)
);

grant select on item_customer_other_info to env_db_website_user;
grant insert on item_customer_other_info to env_db_website_user;
grant update on item_customer_other_info to env_db_website_user;
grant delete on item_customer_other_info to env_db_website_user;

grant select on item_customer_other_info_id_seq to env_db_website_user;
grant update on item_customer_other_info_id_seq to env_db_website_user;
grant usage on item_customer_other_info_id_seq to env_db_website_user;

grant select on item_producer_other_info to env_db_website_user;
grant insert on item_producer_other_info to env_db_website_user;
grant update on item_producer_other_info to env_db_website_user;
grant delete on item_producer_other_info to env_db_website_user;

grant select on item_producer_other_info_id_seq to env_db_website_user;
grant update on item_producer_other_info_id_seq to env_db_website_user;
grant usage on item_producer_other_info_id_seq to env_db_website_user;

grant select on item_shipper_other_info to env_db_website_user;
grant insert on item_shipper_other_info to env_db_website_user;
grant update on item_shipper_other_info to env_db_website_user;
grant delete on item_shipper_other_info to env_db_website_user;

grant select on item_shipper_other_info_id_seq to env_db_website_user;
grant update on item_shipper_other_info_id_seq to env_db_website_user;
grant usage on item_shipper_other_info_id_seq to env_db_website_user;

grant select on function_info to env_db_website_user;
grant insert on function_info to env_db_website_user;
grant update on function_info to env_db_website_user;
grant delete on function_info to env_db_website_user;

grant select on function_info_id_seq to env_db_website_user;
grant update on function_info_id_seq to env_db_website_user;
grant usage on function_info_id_seq to env_db_website_user;

grant select on function_time to env_db_website_user;
grant insert on function_time to env_db_website_user;
grant update on function_time to env_db_website_user;
grant delete on function_time to env_db_website_user;

grant select on function_time_id_seq to env_db_website_user;
grant update on function_time_id_seq to env_db_website_user;
grant usage on function_time_id_seq to env_db_website_user;
