#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aux.h"
#include <hiredis/hiredis.h>
#include <time.h>
#include <math.h>
#include <assert.h>
#include "clib.h"
#include <pqxx/pqxx> 

int main(int argc, char **argv) {
  redisContext *conn;
  redisReply *reply;
  if (argc != 10) {
    printf("\nUsage: %s redis_ip_address redis_ip_port psql_dbname psql_user psql_password psql_host psql_port result_file init_rand\n\n", argv[0]);
    exit(2);
  }
  printf("Invoked with cmdline\n\t");
  for (int i = 0; i < argc; i++)
    printf("%s ", argv[i]);
  printf("\n");
  fflush(stdout);
  init_rand_monitored_sleep(atoi(argv[9]));
  char buffer[1024], *tmp;
  tmp = hostname_to_ip(argv[6]);
  sprintf(buffer, "dbname = %s user = %s password = %s hostaddr = %s port = %s", argv[3], argv[4], argv[5], tmp, argv[7]);
  free(tmp);
  pqxx::connection C(buffer);
  conn = conn_to_redis(argv);
  FILE *f = fopen(argv[8], "w");
  if (!f) {
    perror("Unable to open file");
    exit(3);
  }
  fprintf(f, "order_id|customer_id|item_id|how_many|processed|date_placed|date_due|date_shipped|date_arrived|reason\n");
  fflush(f);
  init_time();
  while (1) {
    aux_monitor(conn, &C, f);
    monitored_sleep(conn, "ext_monitor", 0, 1, "main_sleep");
  }
  fclose(f);

  /* Disconnects and frees the context */
  redisFree(conn);
  print_all(1, "ProducerAPI exiting\n");
  return 0;
}
