#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aux.h"
#include <hiredis/hiredis.h>
#include <time.h>
#include <math.h>
#include <assert.h>
#include "clib.h"
#include <pqxx/pqxx> 

#define DBG_HERE 0

int main(int argc, char **argv) {
  redisContext *conn;
  redisReply *reply;
  if (argc != 9) {
    printf("\nUsage: %s redis_ip_address redis_ip_port psql_dbname psql_user psql_password psql_host psql_port init_rand\n\n\n", argv[0]);
    exit(2);
  }
  printf("Invoked with cmdline\n\t");
  for (int i = 0; i < argc; i++)
    printf("%s ", argv[i]);
  printf("\n");
  fflush(stdout);
  init_rand_monitored_sleep(atoi(argv[8]));
  char buffer[1024], *tmp;
  tmp = hostname_to_ip(argv[6]);
  sprintf(buffer, "dbname = %s user = %s password = %s hostaddr = %s port = %s", argv[3], argv[4], argv[5], tmp, argv[7]);
  free(tmp);
  pqxx::connection C(buffer);
  conn = conn_to_redis(argv);
  init_time();
  while (1) {
    manage_req_from_cp(conn, &C);
    manage_orders(conn, &C);
    monitored_sleep(conn, "producer", 0, 1, "main_sleep");
  }

  /* Disconnects and frees the context */
  redisFree(conn);
  print_all(1, "ProducerAPI exiting\n");
  return 0;
}
